SystemOrganization addCategory: #SourceCity!

TestCase subclass: #BuildingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!BuildingTest methodsFor: 'as yet unclassified' stamp: 'douaille 4/10/2012 15:24'!
testColorMetricsConfig
	"self debug: #testMetricsConfig"
	
	| p d c |
	c := CityImporter new.
	c cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	
	self assert: c city districts size =1.
	self assert: c city widthSelector = #2. 
	

	(c city districts) do:[
		:eachDistrict|
		((eachDistrict model) classes) do:[
			:eachBuilding|
			c importClassAsBuilding: eachBuilding district: eachDistrict.
			].
		].
	
	self assert: (c city districts at: 1)buildings size =2.
	self assert: c city widthSelector = #2.
	self assert: (c city districts at:1) widthSelector = #2.
	self assert: ((c city districts at:1) buildings at:1) colorSelector =0.
	self assert: ((c city districts at:1) buildings at:2) colorSelector =0.! !

!BuildingTest methodsFor: 'as yet unclassified' stamp: 'douaille 4/10/2012 15:23'!
testHeightMetricsConfig
	"self debug: #testMetricsConfig"
	
	| p d c |
	c := CityImporter new.
	c cityNamed: 'CodCT' withPackageNames: #('AST-Core').
	
	self assert: c city districts size =1.
	self assert: c city widthSelector = 2. 

	(c city districts) do:[
		:eachDistrict|
		eachDistrict buildings do:[
			:eachBuilding|
			Transcript cr;show: eachBuilding.
			].
		].
	
	self assert: (c city districts at: 1)buildings size =2.
	self assert: c city widthSelector = #2.
	self assert: (c city districts at:1) widthSelector = #2.
	self assert: ((c city districts at:1) buildings at:1) heightSelector =  ((c city districts at:1) buildings at:1) model selectors size.
	self assert: ((c city districts at:1) buildings at:2) heightSelector =  ((c city districts at:1) buildings at:2) model selectors size.! !

!BuildingTest methodsFor: 'as yet unclassified' stamp: 'douaille 4/10/2012 15:25'!
testWidthMetricsConfig
	"self debug: #testMetricsConfig"
	
	| p d c |
	c := CityImporter new.
	c cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	
	self assert: c city districts size =1.
	self assert: c city widthSelector = #2. 
	

	(c city districts) do:[
		:eachDistrict|
		((eachDistrict model) classes) do:[
			:eachBuilding|
			c importClassAsBuilding: eachBuilding district: eachDistrict. 
			].
		].
	
	self assert: (c city districts at: 1)buildings size =2.
	self assert: c city widthSelector = #2.
	self assert: (c city districts at:1) widthSelector = #2.
	self assert: ((c city districts at:1) buildings at:1) widthSelector = #1"((c city districts at:1) buildings at:1) model allSubclasses size".
	self assert: ((c city districts at:1) buildings at:2) widthSelector =  #1"((c city districts at:1) buildings at:2) model allSubclasses size".! !

TestCase subclass: #CityImporterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!CityImporterTest methodsFor: 'tests' stamp: 'DouailleErwan 4/4/2012 16:58'!
testDisplayFullyImportOfRing
	"self debug: #testFullyImportOfRing"
	
	| cimport ring build height |
	cimport := CityImporter new.
	ring := RPackageOrganizer default packageNames.
	cimport cityNamed: 'CodCT' withPackageNames: ring.
	(cimport city districts) do:[
		:each|
		((each model) classes) do:[
			:eachClass|
			cimport importClassAsBuilding: eachClass district: each.
			].
		].
	"self assert: cimport city districts size = 481.
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	self assert: (cimport city hasDistrictNamed: #'SourceCity')."
	"Transcript cr;show:cimport city size."
	build := 0.
	height := 0.
	(cimport city districts) do:[
		:each|
		(each buildings) do:[
			:eachClass|
			build := build+1.
			(height<eachClass heightSelector)
			ifTrue: [height := (eachClass heightSelector).Transcript cr;show:eachClass;show:height].
			].
		].
	Transcript clear;show:'1 ville - ';show:cimport city districts size;show: ' districts - ';show: build;show:' buildings le plus haut fait : ';show:height.
	"Transcript cr;show: (RPackage new numberOfClasses)."! !

!CityImporterTest methodsFor: 'tests' stamp: 'DouailleErwan 4/5/2012 13:08'!
testFullyImportOfRing
	"self debug: #testFullyImportOfRing"
	"This method test, is just for show us what does normal import realize. How many build, districts ... and max metrics we can find"
	| cimport ring build height |
	cimport := CityImporter new.
	ring := RPackageOrganizer default packageNames.
	cimport cityNamed: 'CodCT' withPackageNames: ring.
	
	"self assert: cimport city districts size = 481.
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	self assert: (cimport city hasDistrictNamed: #'SourceCity')."
	"Transcript cr;show:cimport city size."
	build := 0.
	height := 0.
	(cimport city districts) do:[
		:each|
		(each buildings) do:[
			:eachClass|
			build := build+1.
			(height<eachClass heightSelector)
			ifTrue: [height := (eachClass heightSelector).Transcript cr;show:eachClass;show:height].
			].
		].
	Transcript clear;show:'1 ville - ';show:cimport city districts size;show: ' districts - ';show: build;show:' buildings le plus haut fait : ';show:height.
	"Transcript cr;show: (RPackage new numberOfClasses)."! !

!CityImporterTest methodsFor: 'tests' stamp: 'DouailleErwan 4/5/2012 13:01'!
testImportClassAsBuilding
	"self debug: #testImportClassAsBuilding"
	
	| cimport |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	self assert: cimport city districts size = cimport numberOfDistrict .
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	
	self assert: cimport city districts size = cimport numberOfDistrict .
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	self assert: (cimport city districts at: 1)buildings size = cimport numberOfBuilding.
	
	! !

!CityImporterTest methodsFor: 'tests' stamp: 'DouailleErwan 4/5/2012 10:59'!
testImportPackageAsDistrict
	"self debug: #testImportPackageAsDistrict"
	
	| cimport |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	self assert: cimport city districts size = cimport numberOfDistrict .
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	! !

!CityImporterTest methodsFor: 'tests' stamp: 'DouailleErwan 4/5/2012 10:59'!
testImportPackageAsDistrictNoDuplicate
	"self debug: #testImportPackageAsDistrictNoDuplicate"
	
	| cimport |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: #('AST-Core' 'SourceCity' 'AST-Core').
	self assert: cimport city districts size = cimport numberOfDistrict .
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	self assert: (cimport city hasDistrictNamed: #'SourceCity').
	! !

TestCase subclass: #DistrictTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!DistrictTest methodsFor: 'tests' stamp: 'douaille 4/10/2012 15:01'!
testMetricsConfig
	"self debug: #testMetricsConfig"
	
	| p d c |
	c := CityImporter new.
	c cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	self assert: c city districts size =1.
	self assert: c city widthSelector = 2. ! !

GLViewportMorph subclass: #NBCity
	instanceVariableNames: 'rot ring'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!NBCity commentStamp: '<historical>' prior: 0!
A NBCity is an OpenGL class who can display a reprensentation of SourceCity.!

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/10/2012 16:43'!
building_x: x y: y z: z
	|gl|
	
	gl := display gl.
	gl begin: GL_QUADS;
	
		color3f_red: 0 green: 0 blue: 1; 
		vertex3f_x: x y: 0  z: z; 
		vertex3f_x: x  y: y z: z; 
		vertex3f_x: x+1 y: y z: z; 
		vertex3f_x: x+1 y: 0 z: z; 
		
		color3f_red: 0 green: 1 blue: 0; 
		vertex3f_x: x y: 0  z: z+1; 
		vertex3f_x: x+1 y:0  z: z+1; 
		vertex3f_x: x+1 y: y z: z+1; 
		vertex3f_x: x y: y z: z+1; 
		
		color3f_red: 1 green: 0 blue: 0;
		vertex3f_x: x+1 y: 0  z: z; 
		vertex3f_x: x+1  y: y z: z; 
		vertex3f_x: x+1 y: y  z: z+1; 
		vertex3f_x: x+1 y: 0  z: z+1; 
		
		color3f_red: 1 green: 0 blue: 1; 
		vertex3f_x: x y: 0 z: z+1; 
		vertex3f_x: x y: y z: z+1; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x y: 0 z:z; 
		
		color3f_red: 0 green: 1 blue: 1; 
		vertex3f_x: x y: 0  z:z; 
		vertex3f_x: x+1 y: 0 z: z; 
		vertex3f_x: x+1 y: 0 z: z+1; 
		vertex3f_x: x y: 0 z: z+1; 
		
		color3f_red: 1 green: 1 blue: 0; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x y: y z: z+1; 
		vertex3f_x: x+1 y: y  z: z+1; 
		vertex3f_x: x+1 y: y z: z; 

	end.
	! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/11/2012 11:43'!
changeModel: aNewRing
	ring:= aNewRing! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/12/2012 16:50'!
city_x: x y: y z: z
	|gl|
	
	gl := display gl.
	gl begin: GL_QUADS;
		
		color3f_red: 1 green: 1 blue: 1; 
		vertex3f_x: -1 y: y  z: -1; 
		vertex3f_x: x y:  y z: -1; 
		vertex3f_x: x y:  y z: z; 
		vertex3f_x: -1 y:  y z: z; 
		
		vertex3f_x: -1 y:  y  z: -1; 
		vertex3f_x: -1 y:  y z: z; 
		vertex3f_x: x y:  y  z: z; 
		vertex3f_x: x y:  y z: -1; 

	end.
	! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/10/2012 16:00'!
district: anArrayStart to: anArrayEnd
	|gl|
	gl := display gl.
	gl begin: GL_QUADS;
		
		color3f_red: 0.5 green: 0.5 blue: 0.5; 

		vertex3f_x: anArrayStart first y: anArrayStart second z: anArrayStart third; 
		vertex3f_x: anArrayEnd first y: anArrayStart second z: anArrayStart third; 
		vertex3f_x: anArrayEnd first y: anArrayStart second z: anArrayEnd third; 
		vertex3f_x: anArrayStart first y: anArrayStart second z: anArrayEnd third; 
		
		vertex3f_x: anArrayStart first y: anArrayEnd second z: anArrayStart third; 
		vertex3f_x: anArrayStart first y: anArrayEnd second z: anArrayEnd third; 
		vertex3f_x: anArrayEnd first y: anArrayEnd second z: anArrayEnd third; 
		vertex3f_x: anArrayEnd first y: anArrayEnd second z: anArrayStart third; 

	end.	! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/12/2012 15:57'!
drawBuilding: aDistrict gap: gap x: x z: z dxSize: dxSize

		
	| bxSize bzSize|
	bxSize := x +1 .
	bzSize := z +1.
	aDistrict buildings do: [:building |
		(dxSize < (bxSize+2))
		ifTrue: [
			bzSize := bzSize + 2.
			bxSize := x +1.
			self building_x: bxSize y: building heightSelector asInteger z: bzSize.
		]
		ifFalse: [
			self building_x: bxSize y: building heightSelector asInteger z: bzSize.
			bxSize := bxSize + 2.
		].
	].! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/12/2012 17:01'!
drawCity: anImporter
	
	|sizeArray|
	
	sizeArray := self drawDistrict: anImporter city gap: 2.
	"self city_x: anImporter city widthSelector asInteger y: -0.2 z: anImporter city widthSelector asInteger."
	self city_x: sizeArray first y: -0.2 z: sizeArray second.! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/13/2012 09:46'!
drawDistrict:aCity gap: gap

	| dxSize x dzSize z maxdxSize maxdzSize bxSize bzSize |
	
	x := 0.
	z := 0.
	maxdzSize := 0.
	maxdxSize := 0.
		
	aCity districts do:[:district |
		dxSize := x + (district widthSelector asInteger*2)+1.
		dzSize := z + (district widthSelector asInteger*2)+1.
		self district: {x . 0.1 . z} to: {dxSize . 0.1 . dzSize}.
		
		(maxdzSize < dzSize)
		ifTrue: [ maxdzSize := dzSize].
		
		self drawBuilding: district gap: gap x: x z: z dxSize: dxSize.
		
		x := dxSize + gap.
		( x > 200"(aCityImporter city widthSelector asInteger/2)")
		ifTrue: [
			z := maxdzSize + gap.
			(maxdxSize<x)
			ifTrue: [
				maxdxSize := x+(dxSize - x).
			].
			x := 0.
		]
		ifFalse: [
			maxdxSize := maxdxSize .
		].
	].
	^{maxdxSize+1 . maxdzSize+1}! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/9/2012 19:24'!
initialize
	
	ring := RPackageOrganizer default packageNames.
	super initialize.
	
	rot := 0.
	! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/9/2012 19:25'!
initialize: aListOfPackage
	
	ring := aListOfPackage asSymbol.
	super initialize.
	
	rot := 0.
	! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/6/2012 16:32'!
line_x: x y: y z: z
	|gl|
	
	gl := display gl.
	
	gl begin: GL_LINES;

		color3f_red: 1 green: 0 blue: 0; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x+1 y: y  z: z; 

		color3f_red: 0 green: 1 blue: 0; 
		vertex3f_x: x y: y z: z; 
		vertex3f_x: x y: y+1 z: z;
		 
		color3f_red: 0 green: 0 blue: 1; 
		vertex3f_x: x y:  y z: z; 
		vertex3f_x: x y: y z: z+1;
		
	end.
	! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/6/2012 16:32'!
openInWorld

	super openInWorld.
	
	self startStepping.! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/12/2012 17:03'!
render
	|gl curveRenderer x tab y z  cimport|
	
	gl := display gl.
	display clear: Color black.
	
	gl
		enable: GL_CULL_FACE;
		enable: GL_MULTISAMPLE;
		enable: GL_MULTISAMPLE_ARB;
		depthFunc: GL_LEQUAL;
		enable: GL_LINE_SMOOTH;
		polygonMode_face:GL_FRONT mode: GL_LINE;
		"polygonMode_face: GL_FRONT mode: GL_LINE;"

		matrixMode: GL_PROJECTION;
		loadIdentity;
		frustum_left: (self width/2) negated 
		right: (self width/2) 
		bottom: (self width/2) negated
		top: (self width/2)
		zNear: 0
		zFar: self width .			
	gl
		matrixMode: GL_MODELVIEW;
		loadIdentity;
		scalef_x: 1/300.0 y: 1/300.0  z: 1/300.0 .
	gl rotatef_angle: (rot\\360) x: 1 y: 1 z: 1.
	gl scalef_x:  1 y: 1  z: 1.
	
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: ring "#('SourceCity' )".
	self line_x: -1 y:-1  z:-1. 
	self drawCity: cimport.! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/12/2012 15:47'!
step
	rot := rot + 2.
	self changed! !

!NBCity methodsFor: 'as yet unclassified' stamp: 'douaille 4/8/2012 16:44'!
stepTime
	^ 5! !

!Float methodsFor: '*SourceCity' stamp: 'douaille 4/10/2012 14:35'!
roundedUp
	"Return a rounded up"
	self fractionPart abs = 0.0
	ifTrue: [
		^self truncated
		]
	ifFalse: [
		^self truncated + self sign rounded
		]! !

Object subclass: #CityImporter
	instanceVariableNames: 'classes methods packages city districts buildings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!CityImporter commentStamp: '<historical>' prior: 0!
I'm responsible for populating a city from a model (usually a ring model)!

!CityImporter methodsFor: 'import' stamp: 'douaille 4/12/2012 13:53'!
basicBuilding: aClassName district: aDistrict

	 | b couleur |
	b := Building new model:  aClassName;hisDistrict: aDistrict.
	b heightSelector: (aClassName selectors) size.
	b widthSelector: #1.
	
	aDistrict add: b.
	^b.
	
	"TODO: COLOR
	(aClassName selectors) do:[:each|
		couleur := each li
		
		
	La liste de l'historique de la classe	appel d'une fonction
		d historyArray: aClassName history
		d historyChoice: aClassName history lastVersion"! !

!CityImporter methodsFor: 'import' stamp: 'douaille 4/11/2012 17:32'!
basicDistrict: aPackageName city: aCity

	 | d |
	d := District new model: (self packageNamed: aPackageName);hisCity: aCity.
	d heightSelector: #1.
	d widthSelector: #1"aPackageName classes size".
	city add: d.
	"TODO :
	
	La liste de l'historique du package	appel d'une fonction
		d historyArray: aPackageName history
		d historyChoice: aPackageName history lastVersion"
	^d
	
	! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/3/2012 13:33'!
city
	^city! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/5/2012 10:21'!
cityNamed: aName withPackageNames: aCol

	city := City new model: aName; name: aName.
	aCol do: [:each |
				self importPackageAsDistrict: each ].
	self importClassAsBuilding .! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 11:23'!
districts
	^ city districts.! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/3/2012 13:58'!
ensureBuilding: aClassName district: aDistrict

	^ buildings
			at: aClassName 
			ifAbsentPut: [ self basicBuilding: aClassName district: aDistrict].
			
						! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/3/2012 13:48'!
ensureDistrict: aPackageName

	^districts 
			at: aPackageName 
			ifAbsentPut: [ self basicDistrict: aPackageName city: (self city)].
			
						! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/5/2012 09:42'!
importClassAsBuilding
	(self city districts) do:[
		:each|
		(each model classes) do:[
			:eachClass|
			self importClassAsBuilding: eachClass district: each.
			].
		].! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/3/2012 13:56'!
importClassAsBuilding: aClassName district: aDistrict

	| ctPack |
	ctPack := self ensureBuilding: aClassName district: aDistrict.
	! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/2/2012 15:43'!
importPackageAsDistrict: aPackageName

	| ctPack |
	ctPack := self ensureDistrict: aPackageName.
	! !

!CityImporter methodsFor: 'initialize-release' stamp: 'DouailleErwan 4/3/2012 14:08'!
initialize

	super initialize.
	districts := Dictionary new.
	buildings := Dictionary new.! !

!CityImporter methodsFor: 'utils' stamp: 'DouailleErwan 4/5/2012 10:56'!
numberOfBuilding
	|number|
	number:= 0.
	city districts do:[:each |
		number := number + each buildings size.].
	^number! !

!CityImporter methodsFor: 'utils' stamp: 'DouailleErwan 4/5/2012 10:54'!
numberOfDistrict
	^city districts size! !

!CityImporter methodsFor: 'utils' stamp: 'DouailleErwan 4/2/2012 14:28'!
packageNamed: aString

	^ RPackageOrganizer default packageNamed: aString! !

Object subclass: #CityObject
	instanceVariableNames: 'model widthSelector heightSelector colorSelector historyArray historyChoice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!CityObject commentStamp: '<historical>' prior: 0!
I'm an abstract class root of the city elements!

CityObject subclass: #Building
	instanceVariableNames: 'hisDistrict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!Building commentStamp: '<historical>' prior: 0!
A Building is the level abstraction.!

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 11:33'!
hisDistrict
	^hisDistrict ! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 14:04'!
hisDistrict: aDistrict
	hisDistrict := aDistrict.! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:40'!
printOn: aStream

	hisDistrict ifNotNil: [ aStream
					nextPutAll: hisDistrict asString; 
					nextPutAll: ' -> '].
					
	model ifNotNil: [ aStream 
					nextPutAll: ' Buidling Name : '; 
					nextPutAll: model name].! !

CityObject subclass: #City
	instanceVariableNames: 'districts name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!City commentStamp: '<historical>' prior: 0!
A City represents the largest model element. It contains a list of districts.!

!City methodsFor: 'adding' stamp: 'DouailleErwan 4/4/2012 16:56'!
add: aDistrict

	districts add: aDistrict.
	self widthSelector: (districts size).
	^ aDistrict! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:36'!
districts

	^ districts! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 14:51'!
districts: anObject
	districts := anObject! !

!City methodsFor: 'testing' stamp: 'DouailleErwan 4/2/2012 14:48'!
hasDistrictNamed: aString
	
	^ districts anySatisfy: [:each | each model name = aString]! !

!City methodsFor: 'initialize-release' stamp: 'DouailleErwan 4/5/2012 10:38'!
initialize

	super initialize.
	"districts := Dictionary new."
	districts := OrderedCollection new.! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:38'!
name
	^ name! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:38'!
name: anObject
	name := anObject! !

!City methodsFor: 'accessing' stamp: 'douaille 4/10/2012 09:37'!
printOn: aStream

	model ifNotNil: [ aStream 
					nextPutAll: ' City name : '; 
					nextPutAll: self name].! !

!City methodsFor: 'accessing' stamp: 'douaille 4/10/2012 15:11'!
widthSelector
	
	| tmp |
	tmp := 0.
	districts do: [ :each |
		tmp := tmp + (each widthSelector).
		].
	widthSelector := #tmp.
	^tmp.! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:29'!
colorSelector
	^colorSelector! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:29'!
colorSelector: anObject
	colorSelector := anObject.! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:29'!
heightSelector
	^heightSelector! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:28'!
heightSelector: anObject
	heightSelector := anObject.! !

!CityObject methodsFor: 'accessing' stamp: 'douaille 4/6/2012 11:48'!
historyArray
	^ historyArray! !

!CityObject methodsFor: 'accessing' stamp: 'douaille 4/6/2012 11:48'!
historyArray: anArray
	 historyArray := anArray! !

!CityObject methodsFor: 'accessing' stamp: 'douaille 4/6/2012 11:49'!
historyChoice
	 ^historyChoice! !

!CityObject methodsFor: 'accessing' stamp: 'douaille 4/6/2012 11:49'!
historyChoice: selectedHistory
	 historyChoice := selectedHistory! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:38'!
initialize
	
	self widthSelector: #0.
	self colorSelector: #0.
	self heightSelector: #0.! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:10'!
model 
	"Returns the model associated with the receiver, it can be a class, package...."
	
	^model! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:10'!
model: aModel
	"Set the model associated with the receiver, it can be a class, package...."
	
	model := aModel! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:28'!
widthSelector
	^widthSelector! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/5/2012 10:28'!
widthSelector: anObject
	widthSelector := anObject.! !

CityObject subclass: #District
	instanceVariableNames: 'hisCity buildings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!District commentStamp: '<historical>' prior: 0!
A District is a secondary city abstractions!

!District methodsFor: 'printing' stamp: 'DouailleErwan 4/4/2012 16:40'!
add: aBuilding

	buildings add: aBuilding.
	self widthSelector: (buildings size).
	^ aBuilding.! !

!District methodsFor: 'configuration' stamp: 'DouailleErwan 4/3/2012 14:15'!
buildings
	^buildings! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 11:32'!
hisCity
	^hisCity.! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 11:32'!
hisCity: aCity
	hisCity := aCity.! !

!District methodsFor: 'configuration' stamp: 'DouailleErwan 4/5/2012 10:38'!
initialize 
	

	super initialize.
	"buildings := Dictionary new."
	buildings := OrderedCollection new.! !

!District methodsFor: 'printing' stamp: 'douaille 4/11/2012 14:56'!
printOn: aStream

	hisCity ifNotNil: [ aStream
					nextPutAll: hisCity asString;
					nextPutAll: '-> '].
					
	model ifNotNil: [ aStream 
					nextPutAll: ' District Name : '; 
					nextPutAll: model name;
					nextPutAll: self buildings size ].! !

!District methodsFor: 'accessing' stamp: 'douaille 4/11/2012 17:52'!
widthSelector
	^super widthSelector sqrt asFloat roundedUp! !

Object subclass: #CityVisualization
	instanceVariableNames: 'win title visualize openGL'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!CityVisualization commentStamp: '<historical>' prior: 0!
A CityVisualization is the class who you use to draw 3D visualization of your pakcage which you enter.!

!CityVisualization methodsFor: 'as yet unclassified' stamp: 'douaille 4/10/2012 09:50'!
display
	|fileMenu toolsFirst toolsSecond dock text holder  superClassArray sdock |
	win := StandardWindow new.
	title := ValueHolder new contents: 'City Name'.
	visualize := ValueHolder new contents: 'List of package'.
	
	superClassArray := ListModel new list:  {'Version 1.1'.'Version 1.0'}; selectionIndex: 1.
	toolsFirst := win newToolbar: {
	
		win
			newTextEntryFor: title
			getText: #contents
			setText:  #contents:
			help: 'Insert a name for your city'.
		win
			newTextEntryFor: visualize
			getText: #contents
			setText:  #contents:
			help: 'List of package'.
		win
			newButtonFor: self
			getState: nil
			action: #reload
			arguments: nil
			getEnabled: nil
			labelForm: win theme smallDoItIcon 
			help: 'Visualize a new City' translated.
		win
			newDropListFor: superClassArray
          		list: #list
            	getSelected: #selectionIndex
                	setSelected: #selectionIndex:
                	help: '?'
		}.
		
	toolsSecond := win newToolbar: {
	
		win
			newButtonFor: nil
			getState: nil
			action: #saveFile
			arguments: nil
			getEnabled: nil
			labelForm: win theme smallSaveIcon
			help: 'Save file' translated.
		win
			newButtonFor: nil
			getState: nil
			action: #print
			arguments: nil
			getEnabled: nil
			labelForm: win theme smallPrintIcon
			help: 'Print' translated}.
			
			
		holder := StringHolder new.
		
		text := win
			newTextEditorFor: holder
			getText:  #contents
			setText: #contents:
			getEnabled: nil.
			
		dock := win newToolDockingBar.
		dock
			addMorph: toolsFirst;
			addMorph: toolsSecond.
			
		sdock := win newToolDockingBar.
		sdock
			addMorph: toolsSecond.
		openGL := NBCity new.
		win
			addMorph: dock
			fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0 @ dock minExtent y));
			"addMorph: sdock
			fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (dock minExtent x corner: 0 @ 0 @0));"
			addMorph: openGL
			fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@dock minExtent y corner: 0 @ 0)).
		win
			themeChanged;
			title: 'SourceCity';
			openInWorld
		
		! !

!CityVisualization methodsFor: 'as yet unclassified' stamp: 'douaille 4/6/2012 13:37'!
initialize
	self display! !

!CityVisualization methodsFor: 'as yet unclassified' stamp: 'douaille 4/12/2012 15:15'!
reload
	win title: title contents.
	(visualize contents = 'List of package')
	ifTrue: [
		openGL changeModel: RPackageOrganizer default packageNames.
		]
	ifFalse: [
		self halt.
		openGL changeModel: ((visualize contents) asSymbol).
		].! !
